﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace RIAcontrols
{
    [DefaultProperty("SwfMovie")]
    [ToolboxData("<{0}:Flash runat=server></{0}:Flash>")]
    public class Flash : WebControl, INamingContainer
    {
        #region Public Properties

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue("")]
        [Localizable(true)]
        public String SwfMovie
        {
            get
            {
                String s = (String)ViewState["SwfMovie"];
                return ((s == null) ? String.Empty : s);
            }

            set
            {
                ViewState["SwfMovie"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue("")]
        [Localizable(true)]
        public String BasePath
        {
            get
            {
                String s = (String)ViewState["BasePath"];
                return ((s == null) ? String.Empty : s);
            }

            set
            {
                ViewState["BasePath"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(Qualities.high)]
        [Localizable(true)]
        public Qualities Quality
        {
            get
            {
                object o = ViewState["Quality"];
                if (o == null)
                    return Qualities.high;
                return (Qualities)o;
            }

            set
            {
                ViewState["Quality"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(ScriptAccessValues.sameDomain)]
        [Localizable(true)]
        public ScriptAccessValues AllowScriptAccess
        {
            get
            {
                object o = (object)ViewState["AllowScriptAccess"];
                return ((o == null) ? ScriptAccessValues.sameDomain : (ScriptAccessValues)o);
            }

            set
            {
                ViewState["AllowScriptAccess"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(WModes.window)]
        [Localizable(true)]
        public WModes WMode
        {
            get
            {
                object o = (object)ViewState["WMode"];
                return ((o == null) ? WModes.window : (WModes)o);
            }

            set
            {
                ViewState["WMode"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(false)]
        [Localizable(true)]
        public Boolean AllowFullScreen
        {
            get
            {
                object o = ViewState["AllowFullScreen"];
                if (o == null)
                    return false;

                return (Boolean)o;
            }

            set
            {
                ViewState["AllowFullScreen"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(false)]
        [Localizable(true)]
        public Boolean Menu
        {
            get
            {
                object o = ViewState["Menu"];
                if (o == null)
                    return false;

                return (Boolean)o;
            }

            set
            {
                ViewState["Menu"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(Alignments.middle)]
        [Localizable(true)]
        public Alignments Align
        {
            get
            {
                object o = (object)ViewState["Align"];
                return ((o == null) ? Alignments.middle : (Alignments)o);
            }

            set
            {
                ViewState["Align"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(Scales.showall)]
        [Localizable(true)]
        public Scales Scale
        {
            get
            {
                object o = (object)ViewState["Scale"];
                return ((o == null) ? Scales.showall : (Scales)o);
            }

            set
            {
                ViewState["Scale"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(SAlignments.C)]
        [Localizable(true)]
        public SAlignments SAlign
        {
            get
            {
                object o = (object)ViewState["SAlign"];
                return ((o == null) ? SAlignments.C : (SAlignments)o);
            }

            set
            {
                ViewState["SAlign"] = value;
            }
        }

        [Bindable(true)]
        [Category("Misc")]
        [DefaultValue(null)]
        [Localizable(true)]
        public String FlashVars
        {
            get
            {
                String s = (String)ViewState["FlashVars"];
                return ((s == null) ? String.Empty : s);
            }

            set
            {
                ViewState["FlashVars"] = value;
            }
        }

        [PersistenceMode(PersistenceMode.InnerProperty)]
        public ITemplate NoFlashTemplate
        {
            get; set;
        }

        public override ControlCollection Controls
        {
            get
            {
                this.EnsureChildControls();
                return base.Controls;
            }
        }

        #endregion

        #region Protected Properties
        protected override HtmlTextWriterTag TagKey
        {
            get
            {
                return HtmlTextWriterTag.Object;
            }
        }

        #endregion

        #region Protected Methods
        protected override void AddAttributesToRender(HtmlTextWriter writer)
        {
            writer.AddAttribute(HtmlTextWriterAttribute.Id, this.ClientID);
            writer.AddAttribute(HtmlTextWriterAttribute.Name, this.ID);
            writer.AddAttribute(HtmlTextWriterAttribute.Width, this.Width.ToString());
            writer.AddAttribute(HtmlTextWriterAttribute.Height, this.Height.ToString());
            writer.AddAttribute(HtmlTextWriterAttribute.Type, "application/x-shockwave-flash");
            writer.AddAttribute("data", this.ResolveUrl(this.SwfMovie));
        }

        protected override void RenderContents(HtmlTextWriter output)
        {
            output.Indent++;

            // Movie
            AddParam(output, "movie", this.ResolveUrl(this.SwfMovie));

            // Quality
            AddParam(output, "quality", this.Quality.ToString());

            // BackColor
            if (!this.BackColor.IsEmpty)
            {
                AddParam(output, "bgcolor", String.Format("#{0:X2}{1:X2}{2:X2}", this.BackColor.R, this.BackColor.G, this.BackColor.B));
            }

            // AllowScriptAccess
            AddParam(output, "allowScriptAccess", this.AllowScriptAccess.ToString());

            // AllowFullScreen
            AddParam(output, "allowFullScreen", this.AllowFullScreen.ToString());

            // Menu
            AddParam(output, "menu", this.Menu.ToString());

            // WMode
            AddParam(output, "wmode", this.WMode.ToString());

            // Align
            if (this.Align != Alignments.middle)
            {
                AddParam(output, "align", this.Align.ToString());
            }

            // Scale
            if (this.Scale != Scales.showall)
            {
                AddParam(output, "scale", this.Scale.ToString());
            }

            // SAlign
            if (this.SAlign != SAlignments.C)
            {
                AddParam(output, "salign", this.SAlign.ToString());
            }

            // BasePath
            if (this.BasePath != String.Empty)
            {
                AddParam(output, "base", this.BasePath.ToString());
            }

            // FlashVars
            if (FlashVars != String.Empty)
            {
                AddParam(output, "flashvars", this.FlashVars.ToString());
            }

            base.RenderChildren(output);
            
        }

        protected override void CreateChildControls()
        {
            if (NoFlashTemplate != null)
            {
                Control NoFlashTemplateHost = new Control();
                NoFlashTemplate.InstantiateIn(NoFlashTemplateHost);
                Controls.Add(NoFlashTemplateHost);
            }

            base.CreateChildControls();
        }

        #endregion

        #region Public Methods
        public void ClearFlashVars()
        {
            this.FlashVars = String.Empty;
        }

        public String GetFlashVar(String VarKey)
        {
            Dictionary<String, String> dVars = this.GetFlashVars();

            if (dVars.ContainsKey(VarKey))
            {
                return dVars[VarKey];
            }
            else
            {
                return String.Empty;
            }
        }

        public void SetFlashVar(String VarKey, String VarValue)
        {
            Dictionary<String, String> dVars = this.GetFlashVars();

            if (dVars.ContainsKey(VarKey))
            {
                dVars[VarKey] = VarValue;
            }
            else
            {
                dVars.Add(VarKey, VarValue);
            }

            SetFlashVars(dVars);
        }

        public void RemoveFlashVar(String VarKey)
        {
            Dictionary<String, String> dVars = this.GetFlashVars();

            if (dVars.ContainsKey(VarKey))
            {
                dVars.Remove(VarKey);
                SetFlashVars(dVars);
            }
        }

        public Dictionary<String, String> GetFlashVars()
        {
            Dictionary<String, String> Result = new Dictionary<String, String>();

            foreach (String Param in this.FlashVars.Split(new Char[] { '&' }))
            {
                if (!String.IsNullOrEmpty(Param) && Param.Contains('='))
                {
                    String Key = Param.Substring(0, Param.IndexOf('=')).Trim();
                    String Value = Param.Substring(Param.IndexOf('=') + 1).Trim();
                    Result.Add(Key, Value);
                }
            }

            return Result;
        }

        public void SetFlashVars(Dictionary<String, String> dVars)
        {
            String sFlashVars = String.Empty;

            foreach (String Key in dVars.Keys)
            {
                sFlashVars += String.Format("{0}={1}&", Key, dVars[Key]);
            }

            if (sFlashVars.Length > 0)
            {
                sFlashVars = sFlashVars.Substring(0, sFlashVars.Length - 1);
            }

            FlashVars = sFlashVars;
        }

        #endregion

        #region Private Methods
        private void AddParam(HtmlTextWriter writer, String ParamName, String ParamValue)
        {
            writer.WriteBeginTag("param");
            writer.WriteAttribute("name", ParamName);
            writer.WriteAttribute("value", ParamValue);
            writer.WriteLine(HtmlTextWriter.SelfClosingTagEnd);
        }

        #endregion

        #region Public Enums
        public enum Qualities
        {
            low,
            medium,
            high,
            autoLow,
            autoHigh,
            best
        }

        public enum ScriptAccessValues
        {
            sameDomain,
            never,
            always
        }

        public enum WModes
        {
            window,
            opaque,
            transparent
        }

        public enum Alignments
        {
            middle,
            left,
            right,
            top
        }

        public enum Scales
        {
            showall,
            noborder,
            exactfit,
            noscale
        }

        public enum SAlignments
        {
            C,
            L,
            R,
            T,
            B,
            TL,
            TR,
            BL,
            BR
        }

        #endregion
    }
}
